theory Forbidden_Patterns
imports
  Trs
  "~~/src/HOL/Library/Monad_Syntax"
  Substitution
  Position
begin

datatype location = H | A | B

type_synonym ('f,'v)forb_pattern = "('f,'v)ctxt \<times> ('f,'v)term \<times> location"
type_synonym ('f,'v)forb_patterns = "('f,'v)forb_pattern set"

definition fpstep_cond_single :: "('f,'v) forb_pattern \<Rightarrow> pos \<Rightarrow> ('f,'v)term \<Rightarrow> bool"
where "fpstep_cond_single pt p t \<equiv> case pt of (C,u,loc) \<Rightarrow>
  \<not>(\<exists> C' \<sigma>. t = C'\<langle>C\<langle>u\<rangle> \<cdot> \<sigma> \<rangle>  \<and> 
   ((loc = H \<and> p = (hole_pos C') <#> (hole_pos C) (*u \<cdot> \<sigma> = subt_at t p*)) \<or> 
    (loc = A \<and> p < (hole_pos C') <#> (hole_pos C) (*subt_at t p \<rhd> u \<cdot> \<sigma>*)) \<or> 
    (loc = B \<and> p > (hole_pos C') <#> (hole_pos C) (*u \<cdot> \<sigma> \<rhd> subt_at t p*))))"

definition fpstep_cond :: "('f,'v) forb_patterns \<Rightarrow> pos \<Rightarrow> ('f,'v)term \<Rightarrow> bool"
where "fpstep_cond \<Pi> p t \<equiv> \<forall> pt \<in> \<Pi>. fpstep_cond_single pt p t"


definition fpstep_r_p_s :: 
 "('f,'v) forb_patterns \<Rightarrow> ('f,'v)trs \<Rightarrow> ('f, 'v) rule \<Rightarrow> pos \<Rightarrow> ('f, 'v) subst \<Rightarrow> 
  ('f,'v)term \<Rightarrow> ('f,'v)term \<Rightarrow> bool"
 where "fpstep_r_p_s \<Pi> R lr p \<sigma> s t \<equiv> (s, t) \<in> rstep_r_p_s R lr p \<sigma> \<and> fpstep_cond \<Pi> p s"

definition fpstep_p :: "('f,'v) forb_patterns \<Rightarrow> ('f,'v)trs \<Rightarrow> pos \<Rightarrow> ('f,'v)trs"
where "fpstep_p \<Pi> R p = {(s,t) | s t.(\<exists> lr \<sigma>. (s,t) \<in> rstep_r_p_s R lr p \<sigma> \<and> fpstep_cond \<Pi> p s)}"

definition fpstep :: "('f,'v) forb_patterns \<Rightarrow> ('f,'v)trs  \<Rightarrow> ('f,'v)trs"
where "fpstep \<Pi> R = {(s,t). \<exists> p. (s,t) \<in>  fpstep_p \<Pi> R p}"

lemmas fpstep_defs = fpstep_def fpstep_p_def

lemma fpstep_pI: "(s,t) \<in> rstep_r_p_s R lr p \<sigma> \<Longrightarrow> fpstep_cond \<Pi> p s \<Longrightarrow> (s,t) \<in> fpstep_p \<Pi> R p" 
  unfolding fpstep_defs by blast

lemma fpstep_pE[elim]: "(s,t) \<in> fpstep_p \<Pi> R p \<Longrightarrow> 
 \<lbrakk>\<And> \<sigma> lr. (s,t) \<in> rstep_r_p_s R lr p \<sigma> \<Longrightarrow> fpstep_cond \<Pi> p s \<Longrightarrow> P\<rbrakk> \<Longrightarrow> P"
  unfolding fpstep_defs by blast

hide_const (open) A B H

end
