(*
Copyright 2009-2013 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Linear_Orders
imports
  Labelings
  Term
  "~~/src/HOL/Library/List_lexord"
  "~~/src/HOL/Library/Char_nat"
  "$AFP/Datatype_Order_Generator/Derive"
begin

(* text define own char order, since
  1) Char_ord loads Prod_ord and
  2) Prod_ord is incompatible with Prod_ord in AFP which is required by RBTMap..
*)
instantiation char :: linorder
begin
fun less_eq_char :: "char \<Rightarrow> char \<Rightarrow> bool" where "less_eq_char c d = (nat_of_char c \<le> nat_of_char d)"
fun less_char :: "char \<Rightarrow> char \<Rightarrow> bool" where "less_char c d = (nat_of_char c < nat_of_char d)"

instance
proof
  fix x y :: char
  assume "x \<le> y" and "y \<le> x"
  hence "nat_of_char x = nat_of_char y" (is "?x = ?y") by auto
  hence "char_of_nat ?x = char_of_nat ?y" by simp
  thus "x = y" unfolding char_of_nat_of_char .
qed auto
end

derive linorder lab
derive linorder "term"

end
