(*
Copyright 2009-2013 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Min_Set_Order_Impl
  imports List_Order_Impl Min_Set_Order
begin

definition min_set_ext :: "'a list_ext_impl" where "min_set_ext s_ns \<equiv> \<lambda> as bs. 
  (bs \<noteq> [] \<and> (\<forall> a \<in> set as. \<exists> b \<in> set bs. fst (s_ns a b)),  
  (\<forall> a \<in> set as. \<exists> b \<in> set bs. snd (s_ns a b)))"


lemma min_set_ext_list_ext: "\<exists> s ns. list_order_extension_impl s ns min_set_ext"
proof(intro exI)
  let ?s = "min_set_s_order"
  let ?ns = "min_set_ns_order"
  show "list_order_extension_impl ?s ?ns min_set_ext"
  proof
    fix s ns
    show "?s {(a,b). s a b} {(a,b). ns a b} = {(as,bs). fst (min_set_ext (\<lambda> a b. (s a b, ns a b)) as bs)}" unfolding min_set_ext_def min_set_s_order_def by auto
  next
    fix s ns
    show "?ns {(a,b). s a b} {(a,b). ns a b} = {(as,bs). snd (min_set_ext (\<lambda> a b. (s a b, ns a b)) as bs)}" unfolding min_set_ext_def min_set_ns_order_def by auto
  next
    fix s ns s' ns' as bs
    assume "set as \<times> set bs \<inter> ns \<subseteq> ns'"
           "set as \<times> set bs \<inter> s \<subseteq> s'"
           "(as,bs) \<in> ?s s ns"
    thus "(as,bs) \<in> ?s s' ns'" unfolding min_set_s_order_def by blast
  next
    fix s ns s' ns' as bs
    assume "set as \<times> set bs \<inter> ns \<subseteq> ns'"
           "set as \<times> set bs \<inter> s \<subseteq> s'"
           "(as,bs) \<in> ?ns s ns"
    thus "(as,bs) \<in> ?ns s' ns'" unfolding min_set_ns_order_def by blast
  qed
qed

end
